#!/usr/bin/python
import os, cgi, Cookie
import urllib
from lxml import etree
from math import floor

def readGEO(ip):
  return (urllib.urlopen("http://api.hostip.info/?ip="+ ip).read())

def parseGEO(xmlString):
  return etree.fromstring(xmlString)

def latlon(x):
    str = x.xpath("//gml:coordinates/text()", namespaces={'gml':'http://www.opengis.net/gml'})[0]
    (lon,comma,lat)= str.partition(',')
    return(float(lat),float(lon))

def qra(latlon):
    (lat,lon)=latlon
    lon=lon+180
    lat=lat+90
    return (chr(ord('A') + int(floor(lon/20.0)))+
    chr(ord('A') + int(floor(lat/10.0)))+
    chr(ord('0') + int(floor(10 * ((lon / 20.0) - floor(lon / 20.0)))))+
    chr(ord('0') + int(floor(10 * ((lat / 10.0) - floor(lat / 10.0)))))+
    chr(32 + ord('A') + int(floor(24 * ((lon / 2.0) - floor (lon / 2.0)))))+
    chr(32 + ord('A') + int(floor(24 * (lat - floor(lat))))))


myqra=''
myoffset='0'

c = Cookie.SimpleCookie()
try:
    c.load(os.environ["HTTP_COOKIE"])
    myqra = c["qra"].value
    myoffset = c["offset"].value
except KeyError:
    if 'REMOTE_ADDR' in os.environ:
        try:
            myqra = qra(latlon(parseGEO(readGEO(os.environ['REMOTE_ADDR']))))
        except:
            pass

print "Content-type: application/xml\n"
print '<?xml version="1.0"?>'
print '<data xmlns="">'
print ' <qra>'+myqra+'</qra>'
print ' <offset>'+myoffset+'</offset>'
print '</data>'

